package aspectEditor.aspectEditorUtils;
import java.util.jar.JarFile;
import java.util.*;
import java.io.*;
import edu.neu.ccs.demeter.aplib.*;
import edu.neu.ccs.demeter.*;
class TraversalName {
  protected Ident ident;
  public Ident get_ident() { return ident; }
  public void set_ident(Ident new_ident) { ident = new_ident; }
  public TraversalName() { super(); }
  public TraversalName(Ident ident) {
    super();
    set_ident(ident);
  }
  public static TraversalName parse(java.io.Reader in) throws ParseException { return new Parser(in)._TraversalName(); }
  public static TraversalName parse(java.io.InputStream in) throws ParseException { return new Parser(in)._TraversalName(); }
  public static TraversalName parse(String s) {
    try { return parse(new java.io.StringReader(s)); }
    catch (ParseException e) {
      throw new RuntimeException(e.toString());
    }
  }
  void universal_trv0_bef(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).before(this);
  }

  void universal_trv0_aft(UniversalVisitor _v_) {
    ((UniversalVisitor) _v_).after(this);
  }

  void universal_trv0(UniversalVisitor _v_) {
    universal_trv0_bef(_v_);
    ((UniversalVisitor) _v_).before_ident(this, ident);
    ((UniversalVisitor) _v_).after_ident(this, ident);
    universal_trv0_aft(_v_);
  }

}
